// unnamed package

import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;


class Field
    extends TiledLayer
{
    private final SheepdogCanvas canvas;

    public static final int WIDTH_IN_TILES =  128;
    public static final int HEIGHT_IN_TILES = 128;
    public static final int TILE_WIDTH = 16;
    public static final int TILE_HEIGHT = 16;

    private static int[][] cellTiles;/* =
        {{-3, -2, -3, -1, -2, -1, -3, -1, -2, -3, -1, -2, -3, -1, -2, -1, -3, -1, -2, -3, -1, -2},
         {-2, 18, 22, 22, 22, 22, 17, 23,  1,  5, 23, 10,  4, 23, 23,  9, 23,  2, 23,  5, 23, -3},
         {-1, 19, 14, 21, 21, 13, 20, 23,  2,  4,  3, 18, 22, 22, 22, 22, 22, 22, 22, 17,  3, -1},
         {-2, 19, 11, 17, 23, 19, 20, 23,  5,  2, 23, 19, 14, 21, 21, 21, 13, 14, 13, 20, 23, -2},
         {-3, 15, 13, 20, 23, 19, 20, 23,  1,  3,  9, 19, 20, 23, 10, 23, 19, 20, 19, 20,  9, -1},
         {-2, 23, 19, 20, 23, 19, 20, 23,  9, 23, 23, 19, 20, 23, 10, 23, 19, 20, 19, 20, 23, -3},
         {-1, 23, 19, 11, 22, 12, 11, 22, 22, 22, 22, 12, 11, 22, 17,  9, 19, 20, 19, 20,  2, -2},
         {-3, 23, 19, 14, 21, 13, 14, 21, 21, 21, 21, 13, 14, 21, 16, 23, 19, 20, 19, 20, 23, -3},
         {-2,  1, 19, 20, 23, 19, 20, 23,  7,  7,  7, 19, 20, 23,  4, 23, 19, 20, 19, 20, 23, -1},
         {-1, 23, 19, 20, 23, 19, 20,  2,  9,  9,  9, 19, 20, 23,  3,  4, 19, 20, 19, 20, 23, -2},
         {-3, 23, 19, 20,  2, 19, 20, 23,  9, 23,  3, 19, 20,  5,  2, 23, 19, 20, 19, 20, 23, -3},
         {-2, 10, 19, 20, 23, 19, 20,  2,  9,  9,  9, 19, 20, 23,  9, 23, 19, 20, 19, 20,  2, -3},
         {-1, 23, 19, 11, 22, 12, 11, 22, 22, 22, 22, 12, 11, 22, 22, 22, 12, 11, 12, 20,  3, -1},
         {-2, 23, 19, 14, 21, 21, 21, 21, 13, 14, 21, 21, 21, 21, 21, 21, 13, 14, 13, 20,  1, -2},
         {-3, 23, 19, 20, 23,  9,  9, 23, 19, 20, 23, 23,  9,  9, 23, 23, 19, 20, 19, 20,  5, -1},
         {-2, 23, 19, 20, 10, 10, 10,  9, 19, 20,  1,  2,  3,  9, 10, 10, 19, 20, 19, 20, 23, -3},
         {-1,  4, 19, 20, 23,  9,  9, 23, 19, 20, 23,  4,  2,  9,  9, 23, 19, 20, 19, 20,  2, -2},
         {-3,  2, 19, 20, 23,  1,  4,  9, 19, 20, 23,  2, 23, 23,  9, 23, 19, 20, 19, 20,  3, -3},
         {-2, 23, 15, 16,  5,  2,  3, 23, 19, 11, 22, 22, 22, 22, 22, 22, 12, 11, 12, 20,  2, -1},
         {-1, 23, 23, 23, 23,  4,  1,  1, 15, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 16, 1, -2},
         {-3,  2,  4,  5,  2,  3,  2, 23, 23, 23,  9,  9, 23,  5, 23,  3,  2,  23,  1,  2,  3, -3},
         {-2, -3, -2, -1, -2, -1, -3, -2, -1, -3, -1, -3, -2, -1, -2, -1, -3, -2, -1, -3, -1, -2}};
*/
    public static int FOLD_TILE = 10;
    public static final int[] ANIM_WATER_TILES = {-1,-2,-3};
    public static final int[] WATER_TILES = {6,7,8};
    public static final int[] HOUSE_TILES = {23,24,25,26,27,28,29,30,31,32};
    public static final int[] SMALL_HOUSE_TILES = {23,24,25,26};
    public static final int[] BIG_HOUSE_TILES = {27,28,29,30,31};
    public static final int[] FENCE_TILES = {6,7,8,9,23,24,25,26,27,28,29,30,31,32};
    public static final int[] ROAD_TILES = {11,12,13,14,15,16,17,18,19,20,21,22};
    public static final int[] UP_TILES = {20};
    public static final int[] DOWN_TILES = {19};
    public static final int[] LEFT_TILES = {22};
    public static final int[] RIGHT_TILES = {21};
    public static final int[] TURN_LEFT_TILES = {15,16,17,18};
    public static final int[] POS_TURN_LEFT_TILES = {11,12,13,14};
    public static final int[] POS_TURN_RIGHT_TILES = {11,12,13,14};

    private static int[][] waterFrames = {{6, 7, 8}, {7, 8, 6}, {8, 6, 7}};

    private int tickCount = 0;


    Field(SheepdogCanvas canvas)
    {
        super(WIDTH_IN_TILES,
              HEIGHT_IN_TILES,
              SheepdogMIDlet.createImage("/field.png"),
              TILE_WIDTH,
              TILE_HEIGHT);

        this.canvas = canvas;
        createAnimatedTile(waterFrames[0][0]);      // tile -1
        createAnimatedTile(waterFrames[1][0]);      // tile -2
        createAnimatedTile(waterFrames[2][0]);      // tile -3

        generateTerrain();

        for (int row = 0; row < HEIGHT_IN_TILES; ++row)
        {
            for (int column = 0; column < WIDTH_IN_TILES; ++column)
            {
                setCell(column, row, cellTiles[row][column]);
            }
        }
    }


    int getSheepdogStartX()
    {
        return 20;//getWidth() - WIDTH_IN_TILES*TILE_WIDTH;
    }


    int getSheepdogStartY()
    {
        return 20; //getHeight() - 34;
    }


    void tick()
    {
        int tickState = (tickCount++ >> 3);   // slow down x8
        int tile = tickState % 3;
        setAnimatedTile(-1 - tile, waterFrames[tile][(tickState % 9) / 3]);
    }


    // return true if any part of the rectangle overlaps a water tile
    // or the fence
    boolean containsImpassableArea(int x, int y, int width, int height)
    {
        int rowMin = y / TILE_HEIGHT;
        int rowMax = (y + height - 1) / TILE_HEIGHT;
        int columnMin = x / TILE_WIDTH;
        int columnMax = (x + width - 1) / TILE_WIDTH;

        int cell = getCell(columnMin, rowMin);
        if ((cell < 0) || (!checkFence(cell)))
        {
            return true;
        }
/*
        for (int row = rowMin; row <= rowMax; ++row)
        {
            for (int column = columnMin; column <= columnMax; ++column)
            {
                int cell = getCell(column, row);
                if ((cell < 0) || (!checkFence(cell)))
                {
                    return true;
                }
            }
        }
*/
        return false;
    }


    // returns true if every pixel of the sprite is in the fold
    boolean inFold(Sprite s)
    {
        // we can assume that the sprite's reference pixel is unchanged
        int rowMin = s.getY() / TILE_HEIGHT;
        int rowMax = (s.getY() + s.getHeight() - 1) / TILE_HEIGHT;
        int columnMin = s.getX() / TILE_WIDTH;
        int columnMax = (s.getX() + s.getWidth() - 1) / TILE_WIDTH;

        for (int row = rowMin; row <= rowMax; ++row)
        {
            for (int column = columnMin; column <= columnMax; ++column)
            {
                if (getCell(column, row) != FOLD_TILE)
                {
                    return false;
                }
            }
        }

        return true;
    }

    boolean checkFence(int cell) {
      for( int i=0; i<FENCE_TILES.length;i++)
        if( cell == FENCE_TILES[i])
          return false;
      return true;
    }

    public static boolean isIn(int elem, int[] set) {
      for( int i=0; i<set.length;i++)
        if( elem == set[i])
          return true;
      return false;
    }

    public int getMaxX() {return WIDTH_IN_TILES;}
    public int getMaxY() {return HEIGHT_IN_TILES;}
    public int getElemColRow(int col, int row) {
      col %= WIDTH_IN_TILES;
      row %= HEIGHT_IN_TILES;
      return getCell(col,row);
    }
    public int getElemXY(int col, int row) {
      col /= TILE_WIDTH;
      row /= TILE_HEIGHT;
      return getElemColRow(col,row);
    }

    private void generateTerrain() {
// deklarci
      this.cellTiles = new int[HEIGHT_IN_TILES][];
      for( int j=0; j<HEIGHT_IN_TILES; j++ ) {
        cellTiles[j] = new int[WIDTH_IN_TILES];
      }
// oldals permek
      for( int j = 0; j<HEIGHT_IN_TILES; j++ ) {
        int ran = canvas.getMidlet().random(300)%3 - 3;
        cellTiles[j][0]=ran;
        cellTiles[j][WIDTH_IN_TILES-1]=ran;
      }
// als-fels permek
      for( int j = 0; j<WIDTH_IN_TILES; j++ ) {
        int ran = canvas.getMidlet().random(300)%3 - 3;
        cellTiles[0][j]=ran;
        cellTiles[HEIGHT_IN_TILES-1][j]=ran;
      }

// rrakjuk az utakat
      int lastx = 2;

      while( lastx < WIDTH_IN_TILES-4 ) {
        int honnan = canvas.getMidlet().random(400)%10 + 1;
        int hova = HEIGHT_IN_TILES-(canvas.getMidlet().random(400)%10 + 3);

//        if( lastx==2 )
          honnan = 2;
        hova = HEIGHT_IN_TILES - 3;
        for( int j=honnan; j<=hova; j++ ) {
          setRoad(lastx,j,19);
          setRoad(lastx+1,j,20);
        }

        lastx += canvas.getMidlet().random(400)%7 + 4;
      }

      int lasty = 2;

      while( lasty < HEIGHT_IN_TILES-4 ) {
        int honnan = canvas.getMidlet().random(400)%10 + 1;
        int hova = WIDTH_IN_TILES-(canvas.getMidlet().random(400)%10 + 3);

        honnan = 2;
        hova = WIDTH_IN_TILES - 3;
        for( int j=honnan; j<=hova; j++ ) {
          setRoad(j,lasty,22);
          setRoad(j,lasty+1,21);
        }

        lasty += canvas.getMidlet().random(400)%7 + 4;
      }
// maradk helyekre f hz stb.
      for( int j=1; j<HEIGHT_IN_TILES-1; j++ ) {
        for( int i=1; i<WIDTH_IN_TILES-1; i++ ) {
          if( !isIn(getRoad(i,j),ROAD_TILES) ) {
            int ran=canvas.getMidlet().random(400)%31+1;
            if( /*isIn(ran,ROAD_TILES) ||*/ ran>10 || ran==9 ) {
              ran=canvas.getMidlet().random(400)%5;
              int ran2=canvas.getMidlet().random(400);
              if( i<45 || j<45 || i>80 || j>80 )
                if( ran==0 ) ran=9; // kerts
                else ran+=22; // kis hzak
              else ran+=27; // belvros felhkarcolkkal
            }
            putRoad(i,j,ran);
          }
        }
      }

      int pol = 4;
      while( pol>0 ) {
        int i = canvas.getMidlet().random(WIDTH_IN_TILES-4)+2;
        int j = canvas.getMidlet().random(HEIGHT_IN_TILES-4)+2;
        if( !isIn(getRoad(i, j), ROAD_TILES) && (
            isIn(getRoad(i - 1, j), ROAD_TILES) ||
            isIn(getRoad(i + 1, j), ROAD_TILES) ||
            isIn(getRoad(i, j - 1), ROAD_TILES) ||
            isIn(getRoad(i, j + 1), ROAD_TILES)
            )) {
          pol--;
          putRoad(i,j,32);
        }
      }
      putRoad(1,1,1);
      putRoad(2,1,1);
      putRoad(1,2,1);

    }

    private void setRoad(int col, int row, int roadType) {
      switch(roadType) {
////////////////////////////////////////
        case 19:
          if( getRoad(col,row)==22 ) {
            if( getRoad(col,row-1)==19 || getRoad(col,row-1)==18 || getRoad(col,row-1)==13 )
              putRoad(col,row,12);
            return;
          }
          if( getRoad(col,row)==21) {
            if( getRoad(col,row+1)==19 || getRoad(col,row+1)==15 || getRoad(col,row+1)==12 )
              putRoad(col,row,13);
            return;
          }
          if( getRoad(col,row-1)==21 ) {
            putRoad(col,row,19);
            putRoad(col,row-1,13);
//            return;
          }
          if( getRoad(col,row+1)==22 ) {
            putRoad(col,row,19);
            putRoad(col,row+1,12);
//            return;
          }
          if( getRoad(col,row-1)==15 ) {
            putRoad(col,row,19);
            putRoad(col,row-1,19);
            return;
          }
          if( getRoad(col,row+1)==18 ) {
            putRoad(col,row,19);
            putRoad(col,row+1,19);
            return;
          }
          if( getRoad(col,row) != 12 && getRoad(col,row) != 15 && getRoad(col,row-1)!=19 && getRoad(col,row-1)!=18 && getRoad(col,row-1)!=13 ) {
            putRoad(col,row,18);
            return;
          }
          if( getRoad(col,row) != 12 && getRoad(col,row) != 15 && getRoad(col,row+1)!=19 && getRoad(col,row+1)!=15 && getRoad(col,row+1)!=12 ) {
            putRoad(col,row,15);
            return;
          }
          if( getRoad(col,row) != 12 && getRoad(col,row) != 15 )
            putRoad(col,row,19);
          return;
////////////////////////////////////////////
        case 20:
          if( getRoad(col,row)==22) {
            if( getRoad(col,row-1)==20 || getRoad(col,row-1)==17 || getRoad(col,row-1)==14 )
              putRoad(col,row,11);
            return;
          }
          if( getRoad(col,row)==21) {
            if( getRoad(col,row+1)==20 || getRoad(col,row+1)==16 || getRoad(col,row+1)==11 )
              putRoad(col,row,14);
            return;
          }
          if( getRoad(col,row-1)==21 ) {
            putRoad(col,row,20);
            putRoad(col,row-1,14);
//            return;
          }
          if( getRoad(col,row+1)==22 ) {
            putRoad(col,row,20);
            putRoad(col,row+1,11);
//            return;
          }
          if( getRoad(col,row-1)==16 ) {
            putRoad(col,row,20);
            putRoad(col,row-1,20);
            return;
          }
          if( getRoad(col,row+1)==17 ) {
            putRoad(col,row,20);
            putRoad(col,row+1,20);
            return;
          }
          if( getRoad(col,row) != 11 && getRoad(col,row) != 16 && getRoad(col,row-1)!=20 && getRoad(col,row-1)!=17 && getRoad(col,row-1)!=14 ) {
            putRoad(col,row,17);
            return;
          }
          if( getRoad(col,row) != 11 && getRoad(col,row) != 16 && getRoad(col,row+1)!=20 && getRoad(col,row+1)!=16 && getRoad(col,row+1)!=11 ) {
            putRoad(col,row,16);
            return;
          }
          if( getRoad(col,row) != 11 && getRoad(col,row) != 16 )
            putRoad(col,row,20);
          return;
////////////////////////////////////////
        case 21:
          if( getRoad(col,row)==19) {
            if( getRoad(col-1,row)==21 || getRoad(col-1,row)==15 || getRoad(col-1,row)==14 )
              putRoad(col,row,13);
            return;
          }
          if( getRoad(col,row)==20) {
            if( getRoad(col+1,row)==21 || getRoad(col+1,row)==16 || getRoad(col+1,row)==13 )
              putRoad(col,row,14);
            return;
          }
          if( getRoad(col-1,row)==20 ) {
            putRoad(col,row,21);
            putRoad(col-1,row,14);
//            return;
          }
          if( getRoad(col+1,row)==19 ) {
            putRoad(col,row,21);
            putRoad(col+1,row,13);
//            return;
          }
          if( getRoad(col-1,row)==16 ) {
            putRoad(col,row,21);
            putRoad(col-1,row,21);
            return;
          }
          if( getRoad(col+1,row)==15 ) {
            putRoad(col,row,21);
            putRoad(col+1,row,21);
            return;
          }
          if( getRoad(col,row) != 13 && getRoad(col,row) != 16 && getRoad(col-1,row)!=21 && getRoad(col-1,row)!=15 && getRoad(col-1,row)!=14 ) {
            putRoad(col,row,15);
            return;
          }
          if( getRoad(col,row) != 13 && getRoad(col,row) != 16 && getRoad(col+1,row)!=21 && getRoad(col+1,row)!=16 && getRoad(col+1,row)!=13 ) {
            putRoad(col,row,16);
            return;
          }
          if( getRoad(col,row) != 13 && getRoad(col,row) != 16 )
            putRoad(col,row,21);
          return;
////////////////////////////////////////
        case 22:
          if( getRoad(col,row)==19) {
            if( getRoad(col-1,row)==22 || getRoad(col-1,row)==18 || getRoad(col-1,row)==11 )
              putRoad(col,row,12);
            return;
          }
          if( getRoad(col,row)==20) {
            if( getRoad(col+1,row)==22 || getRoad(col+1,row)==17 || getRoad(col+1,row)==12 )
              putRoad(col,row,11);
            return;
          }
          if( getRoad(col-1,row)==20 ) {
            putRoad(col,row,22);
            putRoad(col-1,row,11);
//            return;
          }
          if( getRoad(col+1,row)==19 ) {
            putRoad(col,row,22);
            putRoad(col+1,row,12);
//            return;
          }
          if( getRoad(col-1,row)==17 ) {
            putRoad(col,row,22);
            putRoad(col-1,row,22);
            return;
          }
          if( getRoad(col+1,row)==18 ) {
            putRoad(col,row,22);
            putRoad(col+1,row,22);
            return;
          }
          if( getRoad(col,row) != 12 && getRoad(col,row) != 17 && getRoad(col-1,row)!=22 && getRoad(col-1,row)!=18 && getRoad(col-1,row)!=11 ) {
            putRoad(col,row,18);
            return;
          }
          if( getRoad(col,row) != 12 && getRoad(col,row) != 17 && getRoad(col+1,row)!=22 && getRoad(col+1,row)!=17 && getRoad(col+1,row)!=12 ) {
            putRoad(col,row,17);
            return;
          }
          if( getRoad(col,row) != 12 && getRoad(col,row) != 17 )
            putRoad(col,row,22);
          return;
        default: return;
      }
    }

    private void putRoad(int col, int row,int elem) {cellTiles[row][col]=elem;}

    private int getRoad(int col, int row) {return cellTiles[row][col];}
}
